{
********************************************************************************
*
*      .
*       .
*
********************************************************************************
}
unit CMLimpl;

interface

uses
  Windows, CMLGeneral;

//    
function GetCMLVersion: DWORD; stdcall; export;

//    
function GetLastClientVersion: DWORD; stdcall; export;

//   -       
function GetDescriptionA: pchar; stdcall; export;

//  ,    
function GetInternalID: DWORD; stdcall; export;

//  ,    
function GetRevision: byte; stdcall; export;

//   
function GetFamily: byte; stdcall; export;

//  
function GetFamilyNameA: pchar; stdcall; export;

//    , 
function GetMaxRAMSize: DWORD; stdcall; export;

//   -    FLAG_XXXX
function GetFlags: DWORD; stdcall; export;

// -   (   )
function GetInputCount: byte; stdcall; export;

// -  
function GetOutputCount: byte; stdcall; export;

//       
function GetOutputDescriptionA(index: DWORD; var Ret: pchar): DWORD; stdcall; export;
{
    ,    Ret     
   0,   ERROR_NOTIMPLEMENTED
}

//    
function GetOutputMask(index: DWORD; var Ret: DWORD): DWORD; stdcall; export;
{
    ,     Ret    0,
    ERROR_NOTIMPLEMENTED
}

//    .  
function GetOutputCtlOptions(index: DWORD; var Ret: DWORD): DWORD; stdcall; export;
{
    ,     Ret   CTL_XXXX   0,
    ERROR_NOTIMPLEMENTED
}

//       (  )
function GetMaxDayplanItemsCount: DWORD; stdcall; export;

//       (  )
function GetMaxYearplanItemsCount: DWORD; stdcall; export;

//     (  )
function GetMaxWorkCyclesCount: DWORD; stdcall; export;

implementation

resourcestring
  MODEL_DESCRIPTION = '-3.3';

  OUTPUT_1 = '1';    OUTPUT_2 = '2';    OUTPUT_3 = '3';    OUTPUT_4 = '4';
  OUTPUT_5 = '5';    OUTPUT_6 = '6';    OUTPUT_7 = '7';    OUTPUT_8 = '8';
  OUTPUT_9 = '9';    OUTPUT_10 = '10';  OUTPUT_11 = '11';  OUTPUT_12 = '12';
  OUTPUT_13 = '13';  OUTPUT_14 = '14';  OUTPUT_15 = '15';  OUTPUT_16 = '16';
  OUTPUT_17 = '17';  OUTPUT_18 = '18';  OUTPUT_19 = '19';  OUTPUT_20 = '20';
  OUTPUT_21 = '21';  OUTPUT_22 = '22';  OUTPUT_23 = '23';  OUTPUT_24 = '24';
  OUTPUT_25 = '25';  OUTPUT_26 = '26';  OUTPUT_27 = '27';  OUTPUT_28 = '28';
  OUTPUT_29 = '29';  OUTPUT_30 = '30';  OUTPUT_31 = '31';  OUTPUT_32 = '32';

const
  MODEL_INTERNAL_ID        = INTERNAL_ID_KDU_3_3S;
  MODEL_REVISION           = MODEL_REVISION_KDU_3_3S;
  MODEL_FAMILY             = FAMILY_KDU_3S;
  MODEL_FAMILY_NAME        = FAMILY_KDU_3S_TITLE;
  MODEL_OUTPUTCOUNT        = 32;
  MODEL_INPUTCOUNT         = 2;
  RAM_SIZE_LIMIT           = 2048;
  MAX_DAYPLAN_ITEMS_COUNT  = 15;
  MAX_YEARPLAN_ITEMS_COUNT = 11;
  MAX_WORK_CYCLES_COUNT    = 25;

  //  
  SUPPORTED_FLAGS: DWORD =
    FLAG_LAMP_HEATING
    or FLAG_YEARPLAN
    or FLAG_ASUDD_KS
    or FLAG_ASSUD_OMSK
    or FLAG_CASCADE_SUPPURT
    or FLAG_SEASON_TIME
    or FLAG_SAVE_BIT_DU
    or FLAG_ASSUD_FILTER_OFF
    or FLAG_CALC_TPROM
    or FLAG_SPECPHASES
//    or FLAG_SPECIAL_DAYS
//    or FLAG_ALL_YEALLOW_BEFORE_BLINK
    or FLAG_RELATIVE_TIME
    or FLAG_EXPAND_YEAR_PLAN
//    or FLAG_EXPAND_YEAR_PLAN_WITH_CALL
//    or FLAG_ADAPTIVE_CONTROL
  ;

  OUTPUT_ARRAY: array[0..MODEL_OUTPUTCOUNT-1] of string = (
    OUTPUT_1,     OUTPUT_2,     OUTPUT_3,     OUTPUT_4,
    OUTPUT_5,     OUTPUT_6,     OUTPUT_7,     OUTPUT_8,
    OUTPUT_9,     OUTPUT_10,    OUTPUT_11,    OUTPUT_12,
    OUTPUT_13,    OUTPUT_14,    OUTPUT_15,    OUTPUT_16,
    OUTPUT_17,    OUTPUT_18,    OUTPUT_19,    OUTPUT_20,
    OUTPUT_21,    OUTPUT_22,    OUTPUT_23,    OUTPUT_24,
    OUTPUT_25,    OUTPUT_26,    OUTPUT_27,    OUTPUT_28,
    OUTPUT_29,    OUTPUT_30,    OUTPUT_31,    OUTPUT_32
  );

  OUTPUT_MASKARRAY:  array[0..MODEL_OUTPUTCOUNT-1] of DWORD = (
    $00020000,    $00040000,    $00080000,    $00000020,
    $00000040,    $00000010,    $00001000,    $00008000,
    $00010000,    $00000008,    $00000002,    $00000080,
    $00004000,    $00000800,    $00002000,    $00000001,
    $80000000,    $00000004,    $00000400,    $00000100,
    $00000200,    $20000000,    $40000000,    $10000000,
    $00200000,    $00400000,    $00800000,    $02000000,
    $04000000,    $08000000,    $00100000,    $01000000
  );

  OUTPUT_CTLARRAY:  array[0..MODEL_OUTPUTCOUNT-1] of DWORD = (
    CTL_I or CTL_U or CTL_P,    CTL_I or CTL_U or CTL_P,
    CTL_I or CTL_U or CTL_P,    CTL_I or CTL_U or CTL_P,
    CTL_I or CTL_U or CTL_P,    CTL_I or CTL_U or CTL_P,
    CTL_I or CTL_U or CTL_P,    CTL_I or CTL_U or CTL_P,
    CTL_I or CTL_U or CTL_P,    CTL_I or CTL_U or CTL_P,
    CTL_I or CTL_U or CTL_P,    CTL_I or CTL_U or CTL_P,
    CTL_I or CTL_U or CTL_P,    CTL_I or CTL_U or CTL_P,
    CTL_I or CTL_U or CTL_P,    CTL_I or CTL_U or CTL_P,
    CTL_I or CTL_U or CTL_P,    CTL_I or CTL_U or CTL_P,
    CTL_I or CTL_U or CTL_P,    CTL_I or CTL_U or CTL_P,
    CTL_I or CTL_U or CTL_P,    CTL_I or CTL_U or CTL_P,
    CTL_I or CTL_U or CTL_P,    CTL_I or CTL_U or CTL_P,
    CTL_I or CTL_U or CTL_P,    CTL_I or CTL_U or CTL_P,
    CTL_I or CTL_U or CTL_P,    CTL_I or CTL_U or CTL_P,
    CTL_I or CTL_U or CTL_P,    CTL_I or CTL_U or CTL_P,
    CTL_I or CTL_U or CTL_P,    CTL_I or CTL_U or CTL_P
  );


function GetCMLVersion: DWORD; stdcall;
begin
  Result := CML_LIBS_VERSION;
end;

function GetLastClientVersion: DWORD; stdcall;
begin
  Result := CML_LAST_SUPPORTED_CLIENT_VERSION;
end;

function GetDescriptionA: pchar; stdcall;
begin
  Result := pchar(string(MODEL_DESCRIPTION));
end;

function GetInternalID: DWORD; stdcall;
begin
  Result := MODEL_INTERNAL_ID;
end;

function GetRevision: byte; stdcall;
begin
  Result := MODEL_REVISION;
end;

function GetFamily: byte; stdcall;
begin
  Result := MODEL_FAMILY;
end;

function GetFamilyNameA: pchar; stdcall;
begin
  Result := pchar(string(MODEL_FAMILY_NAME));
end;

function GetFlags: DWORD; stdcall;
begin
  Result := SUPPORTED_FLAGS;
end;

function GetOutputCount: byte; stdcall;
begin
  Result := MODEL_OUTPUTCOUNT;
end;

function GetInputCount: byte; stdcall;
begin
  Result := MODEL_INPUTCOUNT;
end;

function GetMaxRAMSize: DWORD; stdcall;
begin
  Result := RAM_SIZE_LIMIT;
end;

function GetOutputDescriptionA(index: DWORD; var Ret: pchar): DWORD; stdcall;
begin
  if index < MODEL_OUTPUTCOUNT then
  begin
    Ret := pchar(OUTPUT_ARRAY[index]);
    Result := OPERATION_SUCCESFUL;
  end
  else begin
    Result := ERROR_NOTIMPLEMENTED;
    SetLastError(ERROR_INDEXOUTOFBOUNDS);
  end;
end;

function GetOutputMask(index: DWORD; var Ret: DWORD): DWORD; stdcall;
begin
  if index < MODEL_OUTPUTCOUNT then
  begin
    Ret := OUTPUT_MASKARRAY[index];
    Result := OPERATION_SUCCESFUL;
  end
  else begin
    Result := ERROR_NOTIMPLEMENTED;
    SetLastError(ERROR_INDEXOUTOFBOUNDS);
  end;
end;

function GetOutputCtlOptions(index: DWORD; var Ret: DWORD): DWORD; stdcall;
begin
  if index < MODEL_OUTPUTCOUNT then
  begin
    Ret := OUTPUT_CTLARRAY[index];
    Result := OPERATION_SUCCESFUL;
  end
  else begin
    Result := ERROR_NOTIMPLEMENTED;
    SetLastError(ERROR_INDEXOUTOFBOUNDS);
  end;
end;

function GetMaxDayplanItemsCount: DWORD; stdcall;
begin
  Result := MAX_DAYPLAN_ITEMS_COUNT;
end;

function GetMaxYearplanItemsCount: DWORD; stdcall;
begin
  Result := MAX_YEARPLAN_ITEMS_COUNT;
end;

function GetMaxWorkCyclesCount: DWORD; stdcall;
begin
  Result := MAX_WORK_CYCLES_COUNT;
end;

end.

